## python-pyppmd 1.1.0+ds

=== debian/changelog ===
python-pyppmd (1.1.0+ds-4) unstable; urgency=medium

  * Force to use CFFI for multi-platform compatibility
  * Update cpuinfo module patch

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 30 Jun 2024 00:42:22 +0900

python-pyppmd (1.1.0+ds-3) unstable; urgency=medium

  * Disable flaky fuzzing test
    Fuzzing test sometimes hangups test.
  * patch: Initialize values
    (debian/patches/0003-Initialize-values.patch)
    "buffer" is uninitialized when PyArg_ParseTupleAndKeywords() returned
    error.
  * patch: Skip benchmark tests if cpuinfo module is not supported
    (debian/patches/0004-Skip-benchmark-tests-if-cpuinfo-module-is-not-
    suppor.patch)
    "cpuinfo" modules dose not supports minor platforms.
    This patch skips benchmark tests on those platforms.

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Thu, 02 May 2024 10:06:06 +0900

python-pyppmd (1.1.0+ds-2) unstable; urgency=medium

  * Packaging update
  * patch: Use stdint.h and stdbool.h to determine storage size of each
    data types
    (debian/patches/0001-Use-stdint.h-and-stdbool.h-to-determine-storage-size.patch)
    Upstream code uses architecture name to determin platform register size
    (32/64 bits). But this method is insufficient for minor platforms like
    non-x86/non-ARM platforms.
    This patch uses <stdint.h> and <stdbool.h> to determin correct register
    size even in minor platforms.
  * Standards-Version: 4.7.0 (routine-update)
  * Testsuite: autopkgtest-pkg-pybuild (routine-update)
  * No tab in license text (routine-update)
  * Upgrade Python build sequencer
  * Upgrade Python test sequencer
  * patch: FTBFS fix for Hurd
    (debian/patches/0002-FTBFS-fix-for-Hurd.patch)
    Use "__APPLE__" instead of "__MACH__" if the code is only for macOS.

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 30 Apr 2024 12:32:48 +0900

python-pyppmd (1.1.0+ds-1) unstable; urgency=medium

  * Initial commit (Closes: #1068315)

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 07 Apr 2024 05:57:50 +0900
