=== utils/requirements.txt ===
PyGithub
tabulate
