## python-pyppmd 1.1.1+ds

=== debian/changelog ===
python-pyppmd (1.1.1+ds-1) unstable; urgency=medium

  * New upstream version 1.1.1+ds
  * Rediff patches
  * Renumber patches

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sat, 28 Dec 2024 03:34:44 +0900
