=== debian/control ===
Source: python-pyppmd
Section: python
Testsuite: autopkgtest-pkg-pybuild
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
Standards-Version: 4.7.0
Homepage: https://codeberg.org/miurahr/pyppmd
Rules-Requires-Root: no
Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-all,
  python3-all-dev,
  python3-cffi,
  python3-setuptools,
  python3-setuptools-scm,
  python3-build,
  python3-pytest,
  python3-hypothesis,
  python3-pytest-benchmark,
  python3-pytest-cov,
  python3-pytest-timeout
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-pyppmd
Vcs-Git: https://salsa.debian.org/python-team/packages/python-pyppmd.git

Package: python3-pyppmd
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: PPM (Prediction by partial matching) compression algorithm for Python
 pyppmd module provides classes and functions for compressing and decompressing
 text data, using PPM(Prediction by partial matching) compression algorithm
 which has several variations of implementations. PPMd is the implementation by
 Dmitry Shkarin. PyPPMD use Igor Pavlov's range coder introduced in 7-zip.
