## python-pyppmd 1.2.0%2Bds

=== debian/changelog ===
python-pyppmd (1.2.0+ds-2) unstable; urgency=medium

  * Use V5 format for watch file
  * Use local file for salsa CI
  * Drop Emacs mode line from debian/watch

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 30 Sep 2025 14:46:08 +0900

python-pyppmd (1.2.0+ds-1) unstable; urgency=medium

  * Upgrade Debian policy to 4.7.2
  * New upstream version 1.2.0+ds

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Wed, 07 May 2025 03:12:06 +0900
