=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=pyppmd

# fuzzing tests fails with timeout often
export PYBUILD_TEST_ARGS = -k "not test_ppmd7_fuzzer and \
                               not test_ppmd8_fuzzer"

%:
	dh $@ --buildsystem=pybuild
