## python-pyppmd 1.3.1+ds

=== debian/changelog ===
python-pyppmd (1.3.1+ds-1) unstable; urgency=medium

  * New upstream version 1.3.1+ds
  * Rediff patches

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 30 Nov 2025 21:24:40 +0900

python-pyppmd (1.2.0+ds-6) unstable; urgency=medium

  * Add architecture macro for build rule

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 25 Nov 2025 01:07:55 +0900

python-pyppmd (1.2.0+ds-5) unstable; urgency=medium

  * Disable some tests that requires large memory
  * Display test name for debugging

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 23 Nov 2025 23:39:51 +0900

python-pyppmd (1.2.0+ds-4) unstable; urgency=medium

  * Refactor test arguments
  * Add architecture specific test options

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 23 Nov 2025 11:20:51 +0900

python-pyppmd (1.2.0+ds-3) unstable; urgency=medium

  * Benchmark test is not reliable for ports architecture
  * Make benchmark test as optional one
  * Disable fragile test on ports platforms
  * Update benchmark code
  * "benchmark" marker requires benchmark plugin for any platforms
  * Lintian fix: redundant-rules-requires-root-no-field

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 23 Nov 2025 08:46:47 +0900
