=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
 Standards-Version: 4.7.2
 Homepage: https://codeberg.org/miurahr/pyppmd
-Rules-Requires-Root: no
 Build-Depends:
   debhelper-compat (= 13),
   dh-sequence-python3,
